# An example wsgi file for offspring-web

import os
import sys
import site

## CONFIGURABLE OPTIONS

# Directories to add to sys.path
# ex. ['srv/.virtualenv/lib/python2.5/dist-packages']
ALLDIRS = ['srv/.virtualenv/lib/python2.6/site-packages']

# Offspring Config File
# ex. '/srv/offspring/config/offspring.cfg'
OFFSPRING_CONFIGFILE='/srv/config/offspring.cfg'

# Django settings module to use
# ex. 'offspring.web.settings_production'
DJANGO_SETTINGS_MODULE = 'offspring.web.settings_devel'

## END CONFIGURABLE OPTIONS

# Remember original sys.path.
prev_sys_path = list(sys.path) 

# Add each new site-packages directory.
for directory in ALLDIRS:
  site.addsitedir(directory)

# Reorder sys.path so new directories at the front.
new_sys_path = [] 
for item in list(sys.path): 
    if item not in prev_sys_path: 
        new_sys_path.append(item) 
        sys.path.remove(item) 
sys.path[:0] = new_sys_path 

from django.core.handlers.wsgi import WSGIHandler
os.environ['OFFSPRING_CONFIGFILE'] = OFFSPRING_CONFIGFILE
os.environ['DJANGO_SETTINGS_MODULE'] = DJANGO_SETTINGS_MODULE
application = WSGIHandler()

