# Copyright 2010 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

import os
import sys

class Bootstrap():
    def daemonize (self, stdin='/dev/null', stdout='/dev/null',
                   stderr='/dev/null'):
        # Flush stdout and stderr
        sys.stdout.flush()
        sys.stderr.flush()

        # Do first fork.
        try:
            self.pid = os.fork()
            if self.pid > 0:
                os._exit(0)   # Exit first parent.
        except OSError, e:
            sys.stderr.write(
                "fork #1 failed: (%d) %s\n" % (e.errno, e.strerror))
            sys.exit(1)

        # Decouple from parent environment.
        os.setsid()
        os.chdir("/")
        os.umask(0)

        # Do second fork.
        try:
            self.pid = os.fork()
            if self.pid > 0:
                os._exit(0)   # Exit second parent.
        except OSError, e:
            sys.stderr.write(
                "fork #2 failed: (%d) %s\n" % (e.errno, e.strerror))
            sys.exit(1)

        # Redirect standard file descriptors.
        if stdin is not None:
            si = open(stdin, 'r')
            os.dup2(si.fileno(), sys.stdin.fileno())

        if stdout is not None:
            so = open(stdout, 'a+')
            os.dup2(so.fileno(), sys.stdout.fileno())

        if stderr is not None:
            se = open(stderr, 'a+', 0)
            os.dup2(se.fileno(), sys.stderr.fileno())
