#!/bin/bash

# Copyright 2010 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

Print() {
    STRING="${1}"
    shift || true
    printf "${STRING}\n" "$@"
}

Debug() {
    if [ "${DEBUG}" = "enabled" ]; then
      STRING="D: ${1}"
      shift || true
       Print "${STRING}" "$@" >&2
    fi
}

Info() {
    STRING="I: ${1}"
    shift || true
    Print "${STRING}" "$@"
}

Warning() {
    STRING="W: ${1}"
    shift || true
    Print "${STRING}" "$@"
}

Error() {
    STRING="E: ${1}"
    shift || true
    Print "${STRING}" "$@" >&2
}

Action() {
    STRING="P: ${1}"
    shift || true
    printf "${STRING}... " "$@"
}

Action_done() {
    _RETURN="$?"

    if [ "${_RETURN}" = "0" ]; then
        printf " done.\n"
    else
        printf " failed.\n"
    fi

    return ${_RETURN}
}
