#!/bin/bash

# Copyright 2010 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

Start_logging() {
    Info "Now logging to '%s'." "${1}"
    Resume_logging ${1}

    Print
    Print "=== %s build log: build # %s  ===" "$PROJECT" "$BUILDNAME"
    Print
    Print "I: Building on host %s on %s" "`hostname`" "`date -R`"
    Print
}

Resume_logging() {
    LOGFILE="${1}"
    _LOGDIR="$(dirname ${LOGFILE})"

    if [ -z "${LOGFILE}" ]; then
        Error "Unable to start logging due to no logfile being specified."
        exit 1
    fi

    if [ ! -d "${_LOGDIR}" ]; then
        Error "Unable to start logging as log directory '%s' does not exist" "${_LOGDIR}"
        exit 1
    fi

    exec 6>&1
    exec 7>&2
    exec &> "${LOGFILE}"
}

Stop_logging() {
    exec 1>&6 2>&7 6>&- 7>&-
}
