# Copyright 2010 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

from ConfigParser import (
    NoOptionError,
    SafeConfigParser
)
import os
import sys

config = None

def _read_config():
    global config
    config = SafeConfigParser()

    if os.environ.has_key("OFFSPRING_CONFIGFILE"):
        CONFIGFILE_PATH = os.environ["OFFSPRING_CONFIGFILE"]
    else:
        CONFIGFILE_PATH = "/srv/config/offspring.cfg"
    configFile = None
    try:
        configFile = open(CONFIGFILE_PATH)
        config.readfp(configFile)
    except Exception, e:
        sys.stderr.write("Fatal Error: Unable to parse configuration file '%s'. (%s)\n" \
            % (CONFIGFILE_PATH, e) )
        sys.exit(1)
    finally:
        if configFile is not None:
            configFile.close()

_read_config()

def _make_getter(section):
    def getter(key, *default):
        try:
            return config.get(section, key, *default)
        except NoOptionError:
            if default:
                return default[0]
            else:
                raise
    return getter

def get(section, key):
    return config.get(section, key)

for section in config.sections():
    globals()[section] = _make_getter(section)
