# Copyright 2010 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

import unittest
import xmlrpclib

from offspring.slave import LexbuilderSlave


class TestLexbuilderSlave(unittest.TestCase):

    def setUp(self):
        self.slave = LexbuilderSlave(('localhost', 8760))
        self.slave.start()
        self.x = xmlrpclib.ServerProxy("http://admin:password@localhost:8760")

    def tearDown(self):
        self.slave.stop()

    def test_retrieveState(self):
        self.assertEqual(self.x.getBuilderState(), LexbuilderSlave.STATE_IDLE)


def test_suite():
    loader = unittest.TestLoader()
    return loader.loadTestsFromName(__name__)
