/* Copyright 2010 Canonical Ltd.  This software is licensed under the
 * GNU Affero General Public License version 3 (see the file LICENSE).
 */

/* SmartClient custom components/widgets for offspring-web.
 */

isc.Page.loadStyleSheet("/assets/css/offspring_widgets.css");

isc.defineClass("lexbuildContextMenu", isc.HLayout);

isc.lexbuildContextMenu.addProperties({
    styleName: "lexbuildContextMenu",
    position: "relative",
    width: 260,
    height: 30,
    layoutTopMargin: 5,
    membersMargin: 5,
    context: null,
    contextTrigger: "selectionChanged",
    contextChange: function(context) {
        this.members.forEach(function(member) {
            if (isA.lexbuildContextMenuItem(member))
            {
                member.contextChange(context);
            }
        });
    },
    initWidget: function() {
        this.Super("initWidget", arguments);
        this.observe(this.context, this.contextTrigger, "observer.contextChange(observed)");
    },
});

isc.defineClass("lexbuildContextMenuItem", isc.Label);

isc.lexbuildContextMenuItem.addProperties({
    styleName: "lexbuildContextMenuItem",
    autoDraw: false,
    wrap: false,
    align: "center",
    showRollOver: true,
    showDisabled: true,
    showDisabledIcon: false,
    getContext: function() {
        return this.parentElement.context;
    },
    contextChange: function(context) {
    },
    setDisabled: function(disabled) {
        this.animateFade((disabled ? 50 : 100));
        this.Super("setDisabled", arguments);
    },
});

isc.defineClass("lexbuildModalWindow", isc.Window);

isc.lexbuildModalWindow.addProperties({
    autoCenter: true,
    isModal: true,
    showModalMask: true,
    showMinimizeButton: false,
    headerIconDefaults: {
        height: 16,
        width: 16,
        padding: 7,
        src: "/assets/images/block.png",
    },
    styleName: "lexbuildModalWindow",
    bodyStyle: "lexbuildModalWindowBody",
    headerStyle: "lexbuildModalWindowHeader",
    headerProperties: {
        height: 30,
    },
    headerLabelProperties: {
        styleName: "lexbuildModalWindowHeaderLabel",
        left: 5,
    },
    showEdges: false,
});
