# Copyright 2010 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

#XXX: These should not template tags (?)

from django import template
from django.template.defaultfilters import stringfilter

from offspring import config
from offspring.web.queuemanager.models import Project
from offspring.slave import LexbuilderSlave

register = template.Library()

@register.filter
@stringfilter
def generate_devel_sourceslist(projectName):
    try:
        project = Project.objects.get(name=projectName)
        projectArchiveURI = config.web("archive_uri")
    except:
        return ""

    if project.arch in ('i386', 'amd64'):
        ubuntuPrimaryURI = "http://archive.ubuntu.com/ubuntu"
    else:
        ubuntuPrimaryURI = "http://ports.ubuntu.com"

    sourcesList = "deb %s %s main restricted universe multiverse\n" % (
        ubuntuPrimaryURI, project.series)
    sourcesList += "deb-src %s %s main restricted universe multiverse\n" % (
        ubuntuPrimaryURI, project.series)

    if len(project.suite):
        sourcesList += "deb %s %s-devel public private\n" % (
            projectArchiveURI, project.suite)
        sourcesList += "deb-src %s %s-devel public private\n" % (
            projectArchiveURI, project.suite)

    return sourcesList
generate_devel_sourceslist.is_safe = True

@register.filter
@stringfilter
def link_results(projectName, buildName=None):
    try:
        base_uri = config.web("build_results_uri")
    except:
        return ""

    if buildName is not None:
        try:
            date, buildCount = buildName.rsplit("-", 1)
        except:
            return config.web("build_results_uri")
        return "%s/%s/%s/%s" % (base_uri, projectName, date, buildCount)
    else:
        return "%s/%s" % (base_uri, projectName)
link_results.is_safe = True
