# Copyright 2010 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

from django import template

from offspring.web.queuemanager.models import (
    BuildRequest,
    BuildResult,
    Lexbuilder
)

register = template.Library()

def show_sidebar_failedbuilds():
    return { 'recent_failures' : BuildResult.recentBuildFailures() }
register.inclusion_tag('queuemanager/sidebars/failed_builds.html')(show_sidebar_failedbuilds)

def show_sidebar_queuedbuilds():
    return { 'pending_builds' : BuildRequest.objects.select_related('project', 'requestor').order_by("score").reverse()[:5] }
register.inclusion_tag('queuemanager/sidebars/queued_builds.html')(show_sidebar_queuedbuilds)

def show_sidebar_buildfarm():
    return { 'lexbuilders' : Lexbuilder.objects.exclude(is_active=False).select_related('current_job__project').order_by("name") }
register.inclusion_tag('queuemanager/sidebars/build_farm.html')(show_sidebar_buildfarm)
