from setuptools import setup, find_packages

setup(
    name="offspring",
    version="0.0.1",
    url='https://launchpad.net/offspring',
    license='AGPLv3',
    description="Offspring Image Build System",
    author='Cody A.W. Somerville',
    package_dir={'': 'lib'},
    packages=find_packages('lib'),
    scripts = [
        'lib/offspring/slave/bin/offspring-slave',
        'lib/offspring/master/bin/offspring-master',
        'lib/offspring/web/bin/offspring-web',
    ],
    entry_points = {
        'console_scripts': [
            '../scripts/cron/build-active-projects = offspring.master:build_active_projects',
            '../scripts/cron/process-pending-build-orders = offspring.master:process_pending_build_orders',
            '../scripts/cron/publish-pending-releases = offspring.master.scripts.publish_pending_releases:run',
            '../scripts/cron/sync-launchpad-project-milestones = offspring.master.scripts.sync_launchpad_project_milestones:run',
        ],
    },
)
